package com.insomnia.GUI;
import com.insomnia.parser.RequestData;
import com.insomnia.parser.Saver;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.text.Utilities;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;

public class RequestPanel extends JPanel {
    private VerticalFlowLayout vfLayout = new VerticalFlowLayout();
    private String[] ss = {"JSON","Form Data"};
    private JComboBox Json_FormData = new JComboBox(ss);
    private JPanel body = new JPanel();
    private JPanel auth = new JPanel();
    private JPanel query = new JPanel();
    private JPanel mainCenterHeader = new JPanel(vfLayout);
    private JScrollPane scrollPane_Header_Request = new JScrollPane(mainCenterHeader);
    private HashMap<String , String> headers_values= new HashMap<>();
    private JPanel docs = new JPanel();
    private JTabbedPane tabbedPaneCenterRequest = new JTabbedPane();
    private JTextField headerField = new JTextField("header");
    private JTextField valueField = new JTextField("value");
    private JCheckBox checkBox = new JCheckBox();
    private JButton delete = new JButton();
    private JPanel rightOfHeader = new JPanel();
    private JPanel center_header = new JPanel(new GridLayout(1,2));
    private JPanel header = new JPanel(new BorderLayout());
    private String s []={"Patch","Put","Post","Delete","Get"};
    private JComboBox centerMenu = new JComboBox(s);
    private JTextField URLTextField = new JTextField("http://api.myproduct.com/v1/users");
    private JButton sendButton = new JButton("send");
    private JPanel centerUp = new JPanel(new BorderLayout());

    public JTabbedPane tabbedPaneCenterRequest() throws IOException {
        Border border = BorderFactory.createLineBorder(Color.BLACK,3);
        BufferedImage master;
        master = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\Insomnia\\src\\image\\535246.png"));
        Image scaled = master.getScaledInstance(20,20, java.awt.Image.SCALE_SMOOTH);
        body.setBackground(Color.GRAY);
        body.add(Json_FormData,BorderLayout.NORTH);
        auth.setBackground(Color.GRAY);
        query.setBackground(Color.GRAY);
        mainCenterHeader.setBackground(Color.GRAY);
        scrollPane_Header_Request.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        docs.setBackground(Color.GRAY);
        //request-center
        tabbedPaneCenterRequest.setBackground(Color.GRAY);
        tabbedPaneCenterRequest.add("Body" , body);
        tabbedPaneCenterRequest.add("Auth" , auth);
        tabbedPaneCenterRequest.add("Query" , query);
        tabbedPaneCenterRequest.add("Header" , scrollPane_Header_Request);
        tabbedPaneCenterRequest.add("Docs" , docs);

        MouseAdapter deleteClick = new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                JButton Btn = (JButton) e.getSource();
                //to repair showing
                mainCenterHeader.remove(((JPanel) Btn.getParent()).getParent());
               mainCenterHeader.revalidate();
               mainCenterHeader.repaint();
            }
        };

        delete.addMouseListener(deleteClick);
        MouseAdapter m = new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if (e!=null && !isLastComponent(((Component) e.getSource()).getParent().getParent())) return;
                JTextField newHeaderField = new JTextField("header");
                newHeaderField.addMouseListener(this);
                newHeaderField.setBorder(border);
                JTextField newValueField = new JTextField("value");
                newValueField.setBorder(border);
                JCheckBox newCheckBox = new JCheckBox();
                newCheckBox.setSelected(true);
                JButton newDelete = new JButton();
                newDelete.setPreferredSize(new Dimension(20,20));
                newDelete.setIcon(new ImageIcon(scaled));
                newDelete.addMouseListener(deleteClick);
                JPanel newRightOfHeader = new JPanel();
                newRightOfHeader.add(newCheckBox);
                newRightOfHeader.add(newDelete);
                JPanel new_center_header = new JPanel(new GridLayout(1, 2));
                new_center_header.add(newHeaderField);
                new_center_header.add(newValueField);
                JPanel newHeader = new JPanel(new BorderLayout());
                newHeader.add(newRightOfHeader, BorderLayout.EAST);
                newHeader.add(new_center_header, BorderLayout.CENTER);
                mainCenterHeader.add(newHeader );
                mainCenterHeader.validate();
            }
        };

        mainCenterHeader.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (mainCenterHeader.getComponentCount()==0) m.mouseClicked(null);
            }
        });

        headerField.addMouseListener(m);


        headerField.setFocusable(true);
        headerField.setBorder(border);
        valueField.setBorder(border);
        delete.setIcon(new ImageIcon(scaled));
        delete.setPreferredSize(new Dimension(20,20));
        checkBox.setSelected(true);
        rightOfHeader.add(checkBox);
        rightOfHeader.add(delete);
        center_header.add(headerField);
        center_header.add(valueField);
        header.add(rightOfHeader,BorderLayout.EAST);
        header.add(center_header,BorderLayout.CENTER);
        mainCenterHeader.add(header);
        return tabbedPaneCenterRequest;
    }


    boolean isLastComponent(Component c){
        return mainCenterHeader.getComponent(mainCenterHeader.getComponentCount()-1)==c;
    }

    public HashMap<String,String> getHeaders(){
        HashMap<String,String> headers = new HashMap<>();
        for(Component c : mainCenterHeader.getComponents()){
            if (c instanceof JPanel){
                JPanel nh = (JPanel) c;
                JPanel r = (JPanel)nh.getComponent(0), l = (JPanel) nh.getComponent(1);
                JCheckBox cb = (JCheckBox) r.getComponent(0);
                if (cb.isSelected()){
                    JTextField h = (JTextField) l.getComponent(0);
                    JTextField v = (JTextField) l.getComponent(1);
                    if (!h.getText().trim().isEmpty()){
                        headers.put(h.getText().trim(),v.getText());
                    }
                }
            }
        }
        return headers;
    }

    //request_up
    public JPanel centerUp(){
        sendButton.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                RequestData requestData = new RequestData();
               // requestData.setUploadPath();
                requestData.setUrl(URLTextField.getText());
                super.mouseClicked(e);
                Saver saver = new Saver();
                //set if it is Json or not
                if(Json_FormData.getActionCommand().equals("JSON"));
                requestData.setJson(true);

                requestData.setHeaders(getHeaders());
                for(String h : requestData.getHeaders().keySet()){
                    System.out.println(h+" : "+requestData.getHeaders().get(h));
                }
            }
        });


        centerMenu.setFont(new Font("Arial",20,15 ));
        centerUp.add(centerMenu , BorderLayout.WEST);
        centerUp.add(URLTextField , BorderLayout.CENTER);
        centerUp.add(sendButton , BorderLayout.EAST);
        return centerUp;
    }



    public void createRequestPanel() throws IOException {
        addToMainRequestPanel(centerUp() , tabbedPaneCenterRequest());
    }

    public void addToMainRequestPanel(JPanel centerUp ,JTabbedPane tabbedPaneCenterRequest ){
        this.setLayout(new BorderLayout());
        this.add(centerUp,BorderLayout.NORTH);
        this.add(tabbedPaneCenterRequest , BorderLayout.CENTER);
    }


    public JPanel getRightOfHeader() {
        return rightOfHeader;
    }

    public JPanel getCenter_header() {
        return center_header;
    }

    public JPanel getBody() {
        return body;
    }


    public JPanel getMainCenterHeader() {
        return mainCenterHeader;
    }

    public JScrollPane getScrollPane_Header_Request() {
        return scrollPane_Header_Request;
    }

    public JPanel getDocs() {
        return docs;
    }

    public JTabbedPane getTabbedPaneCenterRequest() {
        return tabbedPaneCenterRequest;
    }

    public JPanel getHeader() {
        return header;
    }

    public JComboBox getCenterMenu() {
        return centerMenu;
    }

    public JPanel getCenterUp() {
        return centerUp;
    }
}
